﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;


namespace CAN_2053C_demo
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();
        }

        private void Btn_GetDLLVersion_Click(object sender, EventArgs e)
        {
            UInt32 ret;
            Char[] ch = new Char[600];
                        
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_DLL_Ver(ch);
            if (ret == 0)
            {
                String _str = new String(ch);
                MessageBox.Show(_str);
            } 
        }

        private void Btn_SearchModule_Click(object sender, EventArgs e)
        {
            UInt32 ret;
            byte Percentage = 0;
            pBar_SearchModule.Value = 0;

            Byte COMPortListCount = 0, BaudRateListCount, DataBitsListCount, StopBitsListCount, ParityListCount, CheckSumListCount;
            Byte[] COMPortList = new Byte[255];
            UInt32[] BaudRateList, DataBitsList, StopBitsList, ParityList, CheckSumList;

            //The VxCAN_SearchCANModule() will search with 2400~921600bps and 5~8 data-bits.
            //It will cost almost 5~10 minutes.
            //ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_SearchCANModule();

            //===================================================================//
            //The user can use VxCAN_SearchCANModuleExAll() instead.
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_GetCurrentCOMPorts(ref COMPortListCount, COMPortList);
            BaudRateList = new UInt32[] { 921600, 115200 };
            DataBitsList = new UInt32[] { 8 }; //8 data-bit
            StopBitsList = new UInt32[] { 1 }; //1 stop-bit
            ParityList = new UInt32[] { 0 }; //0: None parity
            CheckSumList = new UInt32[] { 0, 1 }; //0: Disable Checksum, 1:Enable Checksum
            BaudRateListCount = (Byte)BaudRateList.Count();
            DataBitsListCount = (Byte)DataBitsList.Count();
            StopBitsListCount = (Byte)StopBitsList.Count();
            ParityListCount = (Byte)ParityList.Count();
            CheckSumListCount = (Byte)CheckSumList.Count();
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_SearchCANModuleExAll(
                                            COMPortListCount, COMPortList,
                                            BaudRateListCount, BaudRateList,
                                            DataBitsListCount, DataBitsList,
                                            StopBitsListCount, StopBitsList,
                                            ParityListCount, ParityList,
                                            CheckSumListCount, CheckSumList);
            //===================================================================//

            if (ret == 0)
            {
                while (pBar_SearchModule.Value < pBar_SearchModule.Maximum)
                {

                    ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_IsSearchCANModuleOK(ref Percentage);
                    pBar_SearchModule.Value = Convert.ToInt32(Percentage);                  
                }

                MessageBox.Show("Search Done!");
            }
        }

        private void Btn_GetModuleList_Click(object sender, EventArgs e)
        {
            Byte _TotalVxCANPort=0;
            Byte[] _VxCAN_LocalPortIDList = new Byte[50];
            UInt32 ret = 0;
            UInt32[] _VxCAN_NameIDList = new UInt32[50];
            UInt32[] _VxCAN_IDList = new UInt32[50];
            UInt32[] _VxCAN_COMPortBaudRate = new UInt32[50];
            String[] _VxCAN_NameStr = new String[50];
            String[] _VxCAN_VerStr = new String[50];

            dataGridView1.Columns.Clear();
            dataGridView1.Rows.Clear();
            dataGridView1.Columns.Add("VxCANPort", "VxCANPort");
            dataGridView1.Columns.Add("VxCAN_NameIDList", "VxCAN_NameIDList");
            dataGridView1.Columns.Add("VxCAN_IDList", "VxCAN_IDList");
            dataGridView1.Columns.Add("VxCAN_COMPortBaudRate", "VxCAN_COMPortBaudRate");
            dataGridView1.Columns.Add("VxCAN_NameStr", "VxCAN_NameStr");
            dataGridView1.Columns.Add("VxCAN_VerStr", "VxCAN_VerStr");
            dataGridView1.Columns.Add("VxCAN_LocalPortIDList", "VxCAN_LocalPortIDList");

 

            for (int i = 0; i < 50; i++)
            {
                //Set Default Value
                _VxCAN_NameStr[i] = new String('\0',50);
                _VxCAN_VerStr[i] = new String('\0', 50);
            }



            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_TotalCANPort(ref _TotalVxCANPort, _VxCAN_NameIDList, _VxCAN_IDList, _VxCAN_COMPortBaudRate, _VxCAN_NameStr, _VxCAN_VerStr, _VxCAN_LocalPortIDList);
            if (ret == 0)
            {
                for (int i = 0; i < _TotalVxCANPort; i++)
                {
                    dataGridView1.Rows.Add();
                    dataGridView1["VxCANPort", dataGridView1.Rows.Count - 1].Value = i;
                    dataGridView1["VxCAN_NameIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameIDList[i];
                    dataGridView1["VxCAN_NameIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameIDList[i];
                    dataGridView1["VxCAN_IDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_IDList[i];
                    dataGridView1["VxCAN_COMPortBaudRate", dataGridView1.Rows.Count - 1].Value = _VxCAN_COMPortBaudRate[i];
                    dataGridView1["VxCAN_NameStr", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameStr[i];
                    dataGridView1["VxCAN_VerStr", dataGridView1.Rows.Count - 1].Value = _VxCAN_VerStr[i];
                    dataGridView1["VxCAN_LocalPortIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_LocalPortIDList[i];
                }            
            }
        }
         

        private void Btn_OpenCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_OpenCAN(0, (UInt32)VxCAN_DotNET.VxCAN_DotNET.CAN_BaudRate.BR_1000K);
            if (ret == 0)
            {
                MessageBox.Show("Open CAN Port 0 done!!");
            }
            
        }

        private void Btn_CloseCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(0);
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearTxBuffer(0);
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_CloseCAN(0);

        }

        private void Btn_SendCANMsg_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            UInt32 ret = 0;
            Byte VxCANPort = 0x0, Mode = 0x0, RTR = 0x0, Len = 0x8;
            Byte[] Data = new Byte[8];
            UInt32 ID = 0x600;
            ID += NumID;

            //rd1 is radiobutton of D0~D7.
            if(rd1.Checked)
            {
             Data[0] = 0x40;
             Data[1] = 0x00;
             Data[2] = 0x60;
             Data[3] = 0x01;
             Data[4] = 0x00;
             Data[5] = 0x00;
             Data[6] = 0x00;
             Data[7] = 0x00;
            }
            //rd2 is radiobutton of D0~D7.
            if (rd2.Checked)
            {
             Data[0] = 0x40;
             Data[1] = 0x00;
             Data[2] = 0x60;
             Data[3] = 0x02;
             Data[4] = 0x00;
             Data[5] = 0x00;
             Data[6] = 0x00;
             Data[7] = 0x00;
            }


            //ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send_And_Log(VxCANPort, ID, Mode, RTR, Len, Data, @"C:\VxLog\TLog.txt");
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);           
            if (ret == 0)
            {
                textBox1.Text = "ID = " + ID.ToString("X3") +", "+
                                "Mode = " + Mode.ToString("X1") +", "+
                                "RTR = " + RTR.ToString("X1") +", "+
                                 "Len = " + Len.ToString("X2")+", ";
                for (int i = 0; i < Data.Length; i++)
                {
                    textBox1.Text += "Data[" + i.ToString("X1") + "] = " + Data[i].ToString("X2");
                    if(i!= (Data.Length-1))
                        textBox1.Text +=", ";
                    else
                        textBox1.Text += Environment.NewLine;
                }
                                                
            }

          
        }

        private void Btn_ReceiveCANMsg_Click(object sender, EventArgs e)
        {
            
            //Timer Start/Stop.
            if (!timer1.Enabled)
            {
                MessageBox.Show("Enable!");
                timer1.Start();
            }
            else
            {
                timer1.Stop();
                MessageBox.Show("Disable!!");
            }
        }

        private void Btn_ResetCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ResetCAN(0);
            if(ret == 0)
                MessageBox.Show("Reset CAN Port 0 done!");
        }

        private void Btn_CANStatus_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;
            UInt32 ModuleStatus = 0;
            UInt32 CANChipStatus = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_CANStatus(0, ref ModuleStatus, ref CANChipStatus);
            if(ret == 0)
            {
                MessageBox.Show("Module Status = "+ModuleStatus.ToString());
                MessageBox.Show("CAN Chip Status = " + CANChipStatus.ToString());
            }
        }

        private bool is_start = true;
        //Every five seconds, timer1_Tick is triggering once.
        private void timer1_Tick(object sender, EventArgs e)
        {
            byte Mode = 0, RTR = 0, Len = 0;
            byte[] Data = new Byte[8];
            ushort RxCnt = 0;
            UInt32 ret = 0, ID = 0;
            Double MsgTimeStamps = 0;
            UInt32 TimeOut = 0;


            //dataGridView2.Columns.Clear();
            //dataGridView2.Rows.Clear();
            if (is_start)
            {
                dataGridView2.Columns.Add("ID", "ID");
                dataGridView2.Columns.Add("Mode", "Mode");
                dataGridView2.Columns.Add("RTR", "RTR");
                dataGridView2.Columns.Add("Len", "Len");
                dataGridView2.Columns.Add("Data", "Data");
                dataGridView2.Columns.Add("MsgTimeStamps", "MsgTimeStamps");
                is_start = false;
            }

            while (true && TimeOut++ < 20000)
            {
                ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_RxMsgCount(0, ref RxCnt);
                if (ret == 0)
                {
                    if (RxCnt > 0)
                    {
                        for (int i = 0; i < RxCnt; i++)
                        {

                            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_Receive(0, ref ID, ref Mode, ref RTR, ref Len, Data, ref MsgTimeStamps);
                            if (ret == 0)
                            {
                                dataGridView2.Rows.Add();
                                dataGridView2["ID", dataGridView2.Rows.Count - 1].Value = ID.ToString("X8");
                                dataGridView2["Mode", dataGridView2.Rows.Count - 1].Value = Mode.ToString("X1");
                                dataGridView2["RTR", dataGridView2.Rows.Count - 1].Value = RTR.ToString("X1");
                                dataGridView2["Len", dataGridView2.Rows.Count - 1].Value = Len.ToString("X1");
                                String _str = Data[0].ToString("X2") + ", " + Data[1].ToString("X2") + ", " +
                                              Data[2].ToString("X2") + ", " + Data[3].ToString("X2") + ", " +
                                              Data[4].ToString("X2") + ", " + Data[5].ToString("X2") + ", " +
                                              Data[6].ToString("X2") + ", " + Data[7].ToString("X2");

                                dataGridView2["Data", dataGridView2.Rows.Count - 1].Value = _str;
                                dataGridView2["MsgTimeStamps", dataGridView2.Rows.Count - 1].Value = MsgTimeStamps.ToString();
                            }
                        }
                        break;
                    }
                }
            } 
           
        }


        private void Btn_ResetCANMsg_Click(object sender, EventArgs e)
        {
           dataGridView2.Columns.Clear();
           dataGridView2.Rows.Clear();
           is_start = true;
        }


    }
}
